diff -u -r cl_cvs2/Sources/Display/canvas.cpp cl_cvs/Sources/Display/canvas.cpp
--- cl_cvs2/Sources/Display/canvas.cpp	2004-08-24 01:45:33.000000000 +0200
+++ cl_cvs/Sources/Display/canvas.cpp	2004-05-07 17:15:24.000000000 +0200
@@ -29,11 +29,11 @@
 /////////////////////////////////////////////////////////////////////////////
 // CL_Canvas construction:
 
-CL_Canvas::CL_Canvas() : impl(CL_DisplayTarget::current().create_canvas())
+CL_Canvas::CL_Canvas() : impl(CL_DisplayTarget::current->create_canvas())
 {
 }
 
-CL_Canvas::CL_Canvas(const CL_Surface &initial_active_surface) : impl(CL_DisplayTarget::current().create_canvas())
+CL_Canvas::CL_Canvas(const CL_Surface &initial_active_surface) : impl(CL_DisplayTarget::current->create_canvas())
 {
 	impl->select_surface(initial_active_surface.impl);
 }
diff -u -r cl_cvs2/Sources/Display/display_target.cpp cl_cvs/Sources/Display/display_target.cpp
--- cl_cvs2/Sources/Display/display_target.cpp	2004-08-24 01:44:08.000000000 +0200
+++ cl_cvs/Sources/Display/display_target.cpp	2003-07-21 00:31:49.000000000 +0200
@@ -21,35 +21,27 @@
 
 #include "Display/display_precomp.h"
 #include "display_target.h"
-#include "API/Core/System/error.h"
 
 /////////////////////////////////////////////////////////////////////////////
 // CL_DisplayTarget construction:
 
 CL_DisplayTarget::CL_DisplayTarget()
 {
-        current_target = this;
+	current = this;
 }
 
 CL_DisplayTarget::~CL_DisplayTarget()
 {
-	current_target = 0;
+	current = 0;
 }
 
 /////////////////////////////////////////////////////////////////////////////
 // CL_DisplayTarget attributes:
 
-CL_DisplayTarget *CL_DisplayTarget::current_target = 0;
+CL_DisplayTarget *CL_DisplayTarget::current = 0;
 
 /////////////////////////////////////////////////////////////////////////////
 // CL_DisplayTarget operations:
 
-CL_DisplayTarget& CL_DisplayTarget::current()
-{
-        if (current_target == 0) 
-		throw CL_Error ("You need a display target !");
-	return *current_target;
-}
-
 /////////////////////////////////////////////////////////////////////////////
 // CL_DisplayTarget implementation:
diff -u -r cl_cvs2/Sources/Display/display_target.h cl_cvs/Sources/Display/display_target.h
--- cl_cvs2/Sources/Display/display_target.h	2004-08-24 01:45:12.000000000 +0200
+++ cl_cvs/Sources/Display/display_target.h	2004-02-18 15:32:15.000000000 +0100
@@ -43,8 +43,8 @@
 	virtual ~CL_DisplayTarget();
 
 //! Attributes:
-private:
-	static CL_DisplayTarget *current_target;
+public:
+	static CL_DisplayTarget *current;
 
 //! Operations:
 public:
@@ -57,8 +57,6 @@
 
 	virtual CL_Canvas_Generic *create_canvas()=0;
 
-	static CL_DisplayTarget& current();
-
 	virtual CL_Font_Target* create_system_font_target(
 		CL_Font_Generic *attributes,
 		const std::string &font_name,
diff -u -r cl_cvs2/Sources/Display/display_window.cpp cl_cvs/Sources/Display/display_window.cpp
--- cl_cvs2/Sources/Display/display_window.cpp	2004-08-24 01:47:22.000000000 +0200
+++ cl_cvs/Sources/Display/display_window.cpp	2004-03-10 23:30:13.000000000 +0100
@@ -43,7 +43,7 @@
 	int flipping_buffers)
 : impl(0)
 {
-	impl = CL_DisplayTarget::current().create_window();
+	impl = CL_DisplayTarget::current->create_window();
 	cl_assert(impl != 0); // platform not implemented?
 	if (impl) impl->add_ref();
 
@@ -65,7 +65,7 @@
 CL_DisplayWindow::CL_DisplayWindow(const CL_DisplayWindowDescription &description)
 : impl(0)
 {
-	impl = CL_DisplayTarget::current().create_window();
+	impl = CL_DisplayTarget::current->create_window();
 	cl_assert(impl != 0); // platform not implemented?
 	if (impl) impl->add_ref();
 
diff -u -r cl_cvs2/Sources/Display/font.cpp cl_cvs/Sources/Display/font.cpp
--- cl_cvs2/Sources/Display/font.cpp	2004-08-24 01:48:15.000000000 +0200
+++ cl_cvs/Sources/Display/font.cpp	2004-02-25 23:20:05.000000000 +0100
@@ -100,7 +100,7 @@
 		letters.append(1, (unsigned int)(x));
 
 	impl->target = CL_SharedPtr<CL_Font_Target>(
-		CL_DisplayTarget::current().create_system_font_target(
+		CL_DisplayTarget::current->create_system_font_target(
 			impl.get(),
 			font_name,
 			letters,
@@ -124,7 +124,7 @@
 : impl(new CL_Font_Generic)
 {
 	impl->target = CL_SharedPtr<CL_Font_Target>(
-		CL_DisplayTarget::current().create_system_font_target(
+		CL_DisplayTarget::current->create_system_font_target(
 			impl.get(),
 			font_name,
 			letter_chars,
diff -u -r cl_cvs2/Sources/Display/sprite.cpp cl_cvs/Sources/Display/sprite.cpp
--- cl_cvs2/Sources/Display/sprite.cpp	2004-08-24 01:47:44.000000000 +0200
+++ cl_cvs/Sources/Display/sprite.cpp	2004-05-11 23:25:35.000000000 +0200
@@ -65,7 +65,7 @@
 CL_Sprite::CL_Sprite(const CL_SpriteDescription &spritedescription, bool pack_texture)
 : impl(new CL_Sprite_Generic)
 {
-	if (pack_texture && CL_DisplayTarget::current().enable_packer())
+	if (pack_texture && CL_DisplayTarget::current->enable_packer())
 	{
 		// Fetch max texture size
 		CL_DisplayWindow *window = CL_Display::get_current_window();
diff -u -r cl_cvs2/Sources/Display/surface.cpp cl_cvs/Sources/Display/surface.cpp
--- cl_cvs2/Sources/Display/surface.cpp	2004-08-24 01:44:26.000000000 +0200
+++ cl_cvs/Sources/Display/surface.cpp	2004-05-06 14:36:01.000000000 +0200
@@ -50,7 +50,7 @@
 : impl(0)
 {
 	impl = new CL_Surface_Generic(
-		CL_DisplayTarget::current().create_surface(provider, delete_provider, flag));
+		CL_DisplayTarget::current->create_surface(provider, delete_provider, flag));
 
 	impl->add_ref();
 }